SystemOrganization addCategory: #'Struppi-Core'!

Object subclass: #HGStruppi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Struppi-Core'!

!HGStruppi methodsFor: 'commit' stamp: 'FrancoisStephany 1/3/2012 18:31'!
commit: aString
	| gofer |
	self serializeDirectories.
	gofer := Gofer new repository: self repository.
	self packages do: [:each |
		gofer package: each.
	].
	gofer commit: aString.! !

!HGStruppi methodsFor: 'commit' stamp: 'FrancoisStephany 1/3/2012 19:10'!
destroyStaticFilesClasses
	| package |
	package :=  PackageInfo named: self staticFilesPackageName.
	package classes do: [:each | each removeFromSystem ].! !

!HGStruppi methodsFor: 'accessing' stamp: 'FrancoisStephany 12/30/2011 22:14'!
directories
	" expects a collection of string eg: ''#('static/stylesheets' 'static/javascripts') 
	  those directories will be serialized by TFFiler"
	self subclassResponsibility ! !

!HGStruppi methodsFor: 'accessing' stamp: 'FrancoisStephany 12/30/2011 22:06'!
packages
	self subclassResponsibility.! !

!HGStruppi methodsFor: 'accessing' stamp: 'FrancoisStephany 12/30/2011 22:10'!
repository
	self subclassResponsibility.! !

!HGStruppi methodsFor: 'commit' stamp: 'FrancoisStephany 1/3/2012 19:10'!
restoreDirectories
	| package |
	package :=  PackageInfo named: self staticFilesPackageName.
	package classes do: [:each | each restoreDirectory ]! !

!HGStruppi methodsFor: 'commit' stamp: 'FrancoisStephany 1/3/2012 19:05'!
serializeDirectories
	self destroyStaticFilesClasses.
	self directories do: [:each |
		TFFiler 
			loadDirectory: each
			into: self staticFilesClassNamePrefix , each asLegalSelector
			packageName: self staticFilesPackageName.
	].! !

!HGStruppi methodsFor: 'accessing' stamp: 'FrancoisStephany 1/3/2012 18:52'!
staticFilesClassNamePrefix
	" returns a String"
	self subclassResponsibility.! !

!HGStruppi methodsFor: 'accessing' stamp: 'FrancoisStephany 1/3/2012 18:44'!
staticFilesPackageName
	self subclassResponsibility.! !
